tyrano.plugin.plishop = null;
(function() {
    "use struct";
    var plishop = {};
    tyrano.plugin.plishop = plishop;
    var debugMode,readStart,loadComplete,fileProtocolSetting,protocol,port,serverHost,clientHost,sendParam;

    plishop.isLoading = false;
    plishop.value = -1;
    plishop.earnings = -1;
    plishop.loadStart = function(url,Debug) {
        var urlDatas,paramType;
        debugMode = Debug === "true" || Debug === true;
        
        if(typeof url === "string"){
            urlDatas = url.match(/(https?:\/\/)(plicy.net\/Shop\/Fandisk\/)(\d+)/);
            paramType = 0;
            if(urlDatas){
                paramType = 1;
            }else{
                urlDatas = url.match(/(https?:\/\/)(plicy.net\/FDUser\/)(\d+)/);
                if(urlDatas){
                    paramType = 2;
                }
            }
            if(paramType !== 0){
                readStart(paramType,parseInt(urlDatas[3]));
                return false;
            }
        }
        return true;
    };
    
    protocol = location.protocol;
    port = location.port;
    serverHost = protocol+"//plicy.net/";
    clientHost = protocol+"//"+location.hostname;
    if(port !== ""){
        clientHost += ":" + port;
    }
    sendParam = "host="+encodeURIComponent(clientHost);
    fileProtocolSetting = function(){
        var debugValue,debugEarnings,value,earnings,str;
        str = "";
        value = -1;
        earnings = -1;
        if(debugMode){
            str = "設定する購入数";
            debugValue = parseInt(window.prompt("現在デバッグモードです。\n"+str+"を入力してください。", value));
            if(isFinite(debugValue)){
                value = debugValue;
            }
            
            str = "設定する売上金額";
            debugEarnings = parseInt(window.prompt("現在デバッグモードです。\n"+str+"を入力してください。", value));
            if(isFinite(debugEarnings)){
                earnings = debugEarnings;
            }
        }
        plishop.value = value;
        plishop.earnings = earnings;
        plishop.isLoading = false;
    };
    readStart = function(type,id){
        var url,plicyLoad;
        if(debugMode){
            fileProtocolSetting();
            return;
        }else if(protocol === "file:"){
            fileProtocolSetting();
            return;
        }else{
            url = serverHost + "Shop/Get/"+type+"/"+id;
            plishop.isLoading = true;
            plicyLoad = function(){ 
                var xhr;
                xhr = new XMLHttpRequest();
                xhr.open("POST", url, true);
                xhr.onload = loadComplete;
                xhr.onerror = plicyLoad;//reload
                xhr.withCredentials = true;
                xhr.setRequestHeader( "Content-Type", "application/x-www-form-urlencoded" );
                xhr.send(sendParam);
            };
            plicyLoad();
        }
    };
    loadComplete = function(event){
        var value , json , str , xhr , earnings;
        xhr = event.target;
        str = xhr.responseText;
        json = null;
        value = 0;
        earnings = 0;
        plishop.isLoading = false;
        try{
            json = JSON.parse(str);
        }catch(e){
        }
        if(!json){
            //json error
            value = -1;
            earnings = -1;
        }else{
            try{
                switch(json["Error"]){
                    case 999://login error
                        value = -1;
                        earnings = -1;
                    break;
                    case 500://server error
                        value = -1;
                        earnings = -1;
                    break;
                    case 403://type error
                        value = -1;
                        earnings = -1;
                    break;
                    case 0:
                        earnings = parseInt(json["Earnings"]);
                        value = parseInt(json["Count"]);
                        if(isNaN(earnings)){
                            earnings = -1;//undefined Error
                        }
                        if(isNaN(value)){
                            value = -1;//undefined Error
                        }
                    break;
                }
            }catch(e){
                value = -1;
                earnings = -1;
            }
        }
        plishop.value = value;
        plishop.earnings = earnings;
    };
       
})();
